using Godot;
using System;

public class DebugUI : Control
{
    [Export]
    public NodePath TicksLabelPath { private get; set; }
    private Label _ticksLabel;

    [Export]
    public NodePath PauseLabelPath { private get; set; }
    private Label _pauseLabel;

    [Export]
    public NodePath InteractionModeLabelPath { private get; set; }
    private Label _interactionModeLabel;
    public override void _Ready()
    {
        _ticksLabel = GetNode<Label>(TicksLabelPath);
        _pauseLabel = GetNode<Label>(PauseLabelPath);
        _interactionModeLabel = GetNode<Label>(InteractionModeLabelPath);
    }

    #region Signals
    public void _on_Clock_OnPauseChanged(bool paused) =>
        SetLabelText(_pauseLabel, "pause", paused);

    public void _on_Clock_OnTick(int ticks) =>
        SetLabelText(_ticksLabel, "ticks", ticks);

    public void _on_Interaction_Mode_OnInteractionModeChanged(Mode oldMode, Mode newMode)
    {
        SetLabelText(_interactionModeLabel, "mode", newMode);
    }
    #endregion

    private void SetLabelText(Label label, string key, object value)
    {
        label.Text = $"{key}: {value}";
    }
}
